(module arrayval (lib "eopl.ss" "eopl")
  
  (require "drscheme-init.scm")
  (require "store.scm")
  
  (provide (all-defined))
  
  (define mutarray?
    (lambda (v)
      (reference? v)))

  (define make-array
    (lambda (vals)
      (let ((ref (newref (car vals))))
        (map newref (cdr vals))
        ref)))
  
  (define arrayref
    (lambda (a i)
      (deref (+ i a))))

  (define arrayset
    (lambda (a i val)
      (setref! (+ a i) val)))
  
  
  )

